Subject: Re: [Dime] RFC 3588 - fixed positioned session-ID AVPs

From: "David Lehmann" <[email-masked]>
Date: Wed, 1 Sep 2010 08:55:18 -0400

OK, BNF rules.    IMHO, this should be noted or clarified in section
8.8. e.g.

"When present, the Session-Id SHOULD appear immediately following the
Diameter Header. Further, the message BNF may mandate that the
Session-Id MUST be positioned immediately following the message header.
Indeed, all messages defined in this RFC require such a positioning.
(see Section 3)"

--

David Lehmann

Ulticom, Inc.

856-787-2952

From: Victor Fajardo [mailto:[email-masked]] 
Sent: Tuesday, August 31, 2010 4:25 PM
To: David Lehmann
Cc: Glen Zorn; [email-masked]
Subject: Re: [Dime] RFC 3588 - fixed positioned session-ID AVPs

yes. the BNF sets the positioning/sequencing rules. it's a common
practice in BNFs to place session-id near the head to optimize msg
processing .. etc.

On Tue, Aug 31, 2010 at 3:22 PM, David Lehmann <[email-masked]>
wrote:

So you are stating that the Diameter protocol itself does NOT require
all session-ID AVPs to follow immediately after the message header, but
a message's BNF may require it?  

--

David Lehmann

Ulticom, Inc.

856-787-2952

From: Victor Fajardo [mailto:[email-masked]] 
Sent: Tuesday, August 31, 2010 2:21 PM 

To: David Lehmann
Cc: Glen Zorn; [email-masked]
Subject: Re: [Dime] RFC 3588 - fixed positioned session-ID AVPs

On Tue, Aug 31, 2010 at 1:54 PM, David Lehmann <[email-masked]>
wrote:

The existing text in 8.8 is contradicting the BNF.  

Which BNF though ? There maybe apps beyond 3588 that may not necessarily
put the session-id after the header in their BNF's. In that regard, the
existing text is not contradictory but is meant to be generalized
specially because it describes an AVP and is agnostic to any BNF.

my two cents,

victor

	I am suggesting text that agrees and supports the BNF.  

	If you don't want to modify the text to agree with the BNF, then
I suggest removing the existing text which contradicts it.

	--

	David Lehmann

	Ulticom, Inc.

	856-787-2952

	From: Victor Fajardo [mailto:[email-masked]] 
	Sent: Tuesday, August 31, 2010 11:52 AM
	To: David Lehmann
	Cc: Glen Zorn; [email-masked]
	Subject: Re: [Dime] RFC 3588 - fixed positioned session-ID AVPs

	Hi David,

	On Tue, Aug 31, 2010 at 10:37 AM, David Lehmann
<[email-masked]> wrote:

	Glen,

	That is not what the spec says.  At least, the wording is not
clear and, IMHO, is misleading.  In which "some message" can the
session-id AVP be in any position?

	It seems to me that the wording in section 8.8 should be:  "When
present, the Session-Id MUST appear immediately following the Diameter
Header (see Section 3)."

	As Glen has mentioned, the BNF dictates the positioning of the
AVP. If you add this text you are adding new rules beyond the BNF.

	regards,

	victor

		 

		--

		David Lehmann

		Ulticom, Inc.

		856-787-2952

		From: Glen Zorn [mailto:[email-masked]] 
		Sent: Tuesday, August 31, 2010 9:54 AM
		To: David Lehmann
		Cc: [email-masked]
		Subject: RE: [Dime] RFC 3588 - fixed positioned
session-ID AVPs

		David Lehmann [mailto://[email-masked]]
<mailto:[mailto://[email-masked]%5d>  writes:

		

		

		

		

		

		

		
		Hello,
		Hello.
		In RFC 3588 (and 3588bis), messages with session IDs are
defined with the session ID AVPs with a fixed position which is
immediately following the header. (e.g. section 8.3.1)  
		Yes.
		However, this is in contradiction with section 8.8 which
states, "When present, the Session-Id SHOULD appear immediately
following the Diameter Header (see Section 3)."
		No.
		By using "SHOULD", the spec is stating that the
session-ID AVP could be in any position in the message.

		No, it is stating that the AVP could be in any position
in some message.  The syntax of the existing messages in RFC 3588 is
defined by the associated BNF and in those messages the Session-Id AVP
must immediately follow the Diameter header.

		Hope this helps.

		 ~gwz

		_______________________________________________
		DiME mailing list
		[email-masked]
		https://www.ietf.org/mailman/listinfo/dime

---

From: Victor Fajardo <[email-masked]>
Date: Wed, 1 Sep 2010 09:12:41 -0400

Its good to have some clarity, though the statement below probably needs
some re-org since SHOULD is followed with a MUST and theres a
conditional 'may' in between. Anyway, the statement maybe redundant
since each BNF already tells you where the session-id can be found ..

my 2 cents.

On Wed, Sep 1, 2010 at 8:55 AM, David Lehmann <[email-masked]> wrote:

>  OK, BNF rules.    IMHO, this should be noted or clarified in section 8.8.
> e.g.
>
> “When present, the Session-Id SHOULD appear immediately following the
> Diameter Header. Further, the message BNF may mandate that the Session-Id
> MUST be positioned immediately following the message header.  Indeed, all
> messages defined in this RFC require such a positioning. (see Section 3)”
>
>
>
> --
>
> *David Lehmann*
>
> Ulticom, Inc.
>
> 856-787-2952
>
>
>
> *From:* Victor Fajardo [mailto:[email-masked]]
> *Sent:* Tuesday, August 31, 2010 4:25 PM
>
> *To:* David Lehmann
> *Cc:* Glen Zorn; [email-masked]
> *Subject:* Re: [Dime] RFC 3588 - fixed positioned session-ID AVPs
>
>
>
> So you are stating that the Diameter protocol itself does NOT require all
> session-ID AVPs to follow immediately after the message header, but a
> message’s BNF may require it?
>
>
>
> --
>
> *David Lehmann*
>
> Ulticom, Inc.
>
> 856-787-2952
>
>
>
> *From:* Victor Fajardo [mailto:[email-masked]]
> *Sent:* Tuesday, August 31, 2010 2:21 PM
>
>
> *To:* David Lehmann
> *Cc:* Glen Zorn; [email-masked]
> *Subject:* Re: [Dime] RFC 3588 - fixed positioned session-ID AVPs
>
>
>
>
>
> existing text is not contradictory but is meant to be generalized specially
> because it describes an AVP and is agnostic to any BNF.
>
>
>
> my two cents,
>
> victor
>
>
>
>
>
> If you don’t want to modify the text to agree with the BNF, then I suggest
> removing the existing text which contradicts it.
>
>
>
> --
>
> *David Lehmann*
>
> Ulticom, Inc.
>
> 856-787-2952
>
>
>
> *From:* Victor Fajardo [mailto:[email-masked]]
> *Sent:* Tuesday, August 31, 2010 11:52 AM
> *To:* David Lehmann
> *Cc:* Glen Zorn; [email-masked]
> *Subject:* Re: [Dime] RFC 3588 - fixed positioned session-ID AVPs
>
>
>
> Hi David,
>
> On Tue, Aug 31, 2010 at 10:37 AM, David Lehmann <[email-masked]>
> wrote:
>
> Glen,
>
>
>
> That is not what the spec says.  At least, the wording is not clear and,
> IMHO, is misleading.  In which “*some* message” can the session-id AVP be
> in any position?
>
>
>
> It seems to me that the wording in section 8.8 should be:  “When present,
> the Session-Id MUST appear immediately following the Diameter Header (see
> Section 3).”
>
>
>
> As Glen has mentioned, the BNF dictates the positioning of the AVP. If you
> add this text you are adding new rules beyond the BNF.
>
>
>
> regards,
>
> victor
>
>
>
>
>
>
>
>
>
> --
>
> *David Lehmann*
>
> Ulticom, Inc.
>
> 856-787-2952
>
>
>
> *From:* Glen Zorn [mailto:[email-masked]]
> *Sent:* Tuesday, August 31, 2010 9:54 AM
> *To:* David Lehmann
> *Cc:* [email-masked]
> *Subject:* RE: [Dime] RFC 3588 - fixed positioned session-ID AVPs
>
>
>
> David Lehmann [mailto://[email-masked]] <[mailto://[email-masked]%5d> writes:
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
> Hello,
>
> Hello.
>
> In RFC 3588 (and 3588bis), messages with session IDs are defined with the session ID AVPs with a fixed position which is immediately following the header. (e.g. section 8.3.1)
>
> Yes.
>
> However, this is in contradiction with section 8.8 which states, “When present, the Session-Id SHOULD appear immediately following the Diameter Header (see Section 3).”
>
> No.
>
> By using “SHOULD”, the spec is stating that the session-ID AVP could be in any position in the message.
>
> No, it is stating that the AVP could be in any position in *some*message.  The syntax of the existing messages in RFC 3588 is defined by the
> associated BNF and in *those* messages the Session-Id AVP *must*immediately follow the Diameter header.
>
>
>
>
>
> Hope this helps.
>
>
>
>  ~gwz
>
>

---

From: Tina TSOU <[email-masked]>
Date: Wed, 01 Sep 2010 21:28:38 +0800

Fully agree with Victor for the previous email.

B. R.
Tina
http://tinatsou.weebly.com/index.html

On Sep 1, 2010, at 9:12 PM, Victor Fajardo wrote:

> Its good to have some clarity, though the statement below probably  
> needs some re-org since SHOULD is followed with a MUST and theres a  
> “When present, the Session-Id SHOULD appear immediately following  
> the Diameter Header. Further, the message BNF may mandate that the  
> Session-Id MUST be positioned immediately following the message  
> header.  Indeed, all messages defined in this RFC require such a  
> positioning. (see Section 3)”
>
>
> --
>
> David Lehmann
>
> Ulticom, Inc.
>
> 856-787-2952
>
>
> On Tue, Aug 31, 2010 at 3:22 PM, David Lehmann  
> So you are stating that the Diameter protocol itself does NOT  
> require all session-ID AVPs to follow immediately after the message  
> header, but a message’s BNF may require it?
>
>
> --
>
> David Lehmann
>
> Ulticom, Inc.
>
> 856-787-2952
>
>
> On Tue, Aug 31, 2010 at 1:54 PM, David Lehmann  
> Which BNF though ? There maybe apps beyond 3588 that may not  
> necessarily put the session-id after the header in their BNF's. In  
> that regard, the existing text is not contradictory but is meant to  
> be generalized specially because it describes an AVP and is agnostic  
> to any BNF.
>
>
> my two cents,
>
> victor
>
>
>
> If you don’t want to modify the text to agree with the BNF, then I  
> suggest removing the existing text which contradicts it.
>
>
> --
>
> David Lehmann
>
> Ulticom, Inc.
>
> 856-787-2952
>
>
> That is not what the spec says.  At least, the wording is not clear  
> and, IMHO, is misleading.  In which “some message” can the session- 
> id AVP be in any position?
>
>
> It seems to me that the wording in section 8.8 should be:  “When  
> present, the Session-Id MUST appear immediately following the  
> Diameter Header (see Section 3).”
>
>
> As Glen has mentioned, the BNF dictates the positioning of the AVP.  
> If you add this text you are adding new rules beyond the BNF.
>
>
> regards,
>
> victor
>
>
>
>
>
> --
>
> David Lehmann
>
> Ulticom, Inc.
>
> 856-787-2952
>
>
> Subject: RE: [Dime] RFC 3588 - fixed positioned session-ID AVPs
>
>
> David Lehmann [mailto://[email-masked]] writes:
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
> Hello,
> Hello.
> In RFC 3588 (and 3588bis), messages with session IDs are defined  
> with the session ID AVPs with a fixed position which is immediately  
> following the header. (e.g. section 8.3.1)
> Yes.
> However, this is in contradiction with section 8.8 which states,  
> “When present, the Session-Id SHOULD appear immediately following  
> the Diameter Header (see Section 3).”
> No.
> No, it is stating that the AVP could be in any position in some  
> message.  The syntax of the existing messages in RFC 3588 is defined  
> by the associated BNF and in those messages the Session-Id AVP must  
> immediately follow the Diameter header.
>
>
>
> Hope this helps.
>
>
>  ~gwz
>
>

---

From: "David Lehmann" <[email-masked]>
Date: Wed, 1 Sep 2010 09:28:42 -0400

Reword as necessary.

The reason that a "SHOULD" is followed by a "MUST" is because that seems
to be how diameter is defined, according to the previous posts.

The diameter protocol says "SHOULD" as far as positioning, but the BNF
may override the "SHOULD" with a "MUST".  It seems you are agreeing that
it is confusing. ;-)  This is why clarification is needed.

I think the wording that I provided is dead on, but as I stated, reword
as necessary.

--

David Lehmann

Ulticom, Inc.

856-787-2952

From: Victor Fajardo [mailto:[email-masked]] 
Sent: Wednesday, September 01, 2010 9:13 AM
To: David Lehmann
Cc: Glen Zorn; [email-masked]
Subject: Re: [Dime] RFC 3588 - fixed positioned session-ID AVPs

my 2 cents.

On Wed, Sep 1, 2010 at 8:55 AM, David Lehmann <[email-masked]>
wrote:

--

David Lehmann

Ulticom, Inc.

856-787-2952

To: David Lehmann

--

David Lehmann

Ulticom, Inc.

856-787-2952

To: David Lehmann

 

my two cents,

victor

	--

	David Lehmann

	Ulticom, Inc.

	856-787-2952

	Hi David,

	Glen,

	regards,

	victor

		 

		--

		David Lehmann

		Ulticom, Inc.

		856-787-2952

		

		

		

		

		

		

		

		

		

		

		

		

		

		

		Hello,
		Hello.

		 

		Hope this helps.

		 ~gwz

---

From: Victor Fajardo <[email-masked]>
Date: Wed, 1 Sep 2010 09:45:57 -0400

hmm actually I prefer not to change anything :) ... the current text is
clear that the BNF defines everything. And that the original SHOULD is there
as a clear recommendation

On Wed, Sep 1, 2010 at 9:28 AM, David Lehmann <[email-masked]> wrote:

>  Reword as necessary.
>
>
>
> The reason that a “SHOULD” is followed by a “MUST” is because that seems to
> be how diameter is defined, according to the previous posts.
>
>
>
> The diameter protocol says “SHOULD” as far as positioning, but the BNF *
> may* override the “SHOULD” with a “MUST”.  It seems you are agreeing that
> I think the wording that I provided is dead on, but as I stated, reword as
> necessary.
>
>
>
> --
>
> *David Lehmann*
>
> Ulticom, Inc.
>
> 856-787-2952
>
>
>
> *Sent:* Wednesday, September 01, 2010 9:13 AM
>
> *To:* David Lehmann

---

From: Victor Fajardo <[email-masked]>
Date: Wed, 1 Sep 2010 10:13:53 -0400

Just to be clear in my prev email. I prefer not to change anything in bis.

On Wed, Sep 1, 2010 at 9:45 AM, Victor Fajardo <[email-masked]> wrote:

> On Wed, Sep 1, 2010 at 9:28 AM, David Lehmann <[email-masked]>wrote:
>
>>  Reword as necessary.
>>
>>
>>
>> The reason that a “SHOULD” is followed by a “MUST” is because that seems

---

From: "David Lehmann" <[email-masked]>
Date: Wed, 1 Sep 2010 10:37:00 -0400

Well, at least we found something that we can agree upon! J

--

David Lehmann

Ulticom, Inc.

856-787-2952

From: Victor Fajardo [mailto:[email-masked]] 
Sent: Wednesday, September 01, 2010 10:14 AM
To: David Lehmann
Cc: Glen Zorn; [email-masked]
Subject: Re: [Dime] RFC 3588 - fixed positioned session-ID AVPs

Just to be clear in my prev email. I prefer not to change anything in
bis.

hmm actually I prefer not to change anything :) ... the current text is
clear that the BNF defines everything. And that the original SHOULD is
there as a clear recommendation

On Wed, Sep 1, 2010 at 9:28 AM, David Lehmann <[email-masked]>
wrote:

Reword as necessary.

--

David Lehmann

Ulticom, Inc.

856-787-2952

To: David Lehmann

my 2 cents.

--

David Lehmann

Ulticom, Inc.

856-787-2952

To: David Lehmann

--

David Lehmann

Ulticom, Inc.

856-787-2952

To: David Lehmann

 

my two cents,

victor

	--

	David Lehmann

	Ulticom, Inc.

	856-787-2952

	Hi David,

	Glen,

	regards,

	victor

		 

		--

		David Lehmann

		Ulticom, Inc.

		856-787-2952

		

		

		

		

		

		

		

		

		

		

		

		

		

		

		

		

		

		

		

		

		

		

		

		

		

		

		

		
		Hello,
		Hello.

		 

		Hope this helps.

		 ~gwz

---

From: "Glen Zorn" <[email-masked]>
Date: Thu, 2 Sep 2010 10:58:27 +0700

Victor Fajardo [mailto:[email-masked]] writes:

Its good to have some clarity, 

Clarity is a wonderful thing & 3588bis could probably (still!) use a little
more of it but this point seems so blindingly obvious that further
wordsmithing would be just a waste of time.

though the statement below probably needs some re-org since SHOULD is
followed with a MUST and theres a conditional 'may' in between. Anyway, the
statement maybe redundant since each BNF already tells you where the
session-id can be found ..

my 2 cents.

"When present, the Session-Id SHOULD appear immediately following the
Diameter Header. Further, the message BNF may mandate that the Session-Id
MUST be positioned immediately following the message header.  Indeed, all
messages defined in this RFC require such a positioning. (see Section 3)"

--

David Lehmann

Ulticom, Inc.

856-787-2952

To: David Lehmann

yes. the BNF sets the positioning/sequencing rules. it's a common practice
in BNFs to place session-id near the head to optimize msg processing .. etc.

On Tue, Aug 31, 2010 at 3:22 PM, David Lehmann <[email-masked]> wrote:

So you are stating that the Diameter protocol itself does NOT require all
session-ID AVPs to follow immediately after the message header, but a
message's BNF may require it?  

--

David Lehmann

Ulticom, Inc.

856-787-2952

To: David Lehmann

On Tue, Aug 31, 2010 at 1:54 PM, David Lehmann <[email-masked]> wrote:

 

Which BNF though ? There maybe apps beyond 3588 that may not necessarily put
the session-id after the header in their BNF's. In that regard, the existing
text is not contradictory but is meant to be generalized specially because
it describes an AVP and is agnostic to any BNF.

my two cents,

victor

If you don't want to modify the text to agree with the BNF, then I suggest
removing the existing text which contradicts it.

--

David Lehmann

Ulticom, Inc.

856-787-2952

Hi David,

Glen,

That is not what the spec says.  At least, the wording is not clear and,
IMHO, is misleading.  In which "some message" can the session-id AVP be in
any position?

It seems to me that the wording in section 8.8 should be:  "When present,
the Session-Id MUST appear immediately following the Diameter Header (see
Section 3)."

regards,

victor

 

--

David Lehmann

Ulticom, Inc.

856-787-2952

David Lehmann  <mailto:[mailto://[email-masked]%5d>
[mailto://[email-masked]] writes:

 

 

Hello,
Hello.
In RFC 3588 (and 3588bis), messages with session IDs are defined with the
session ID AVPs with a fixed position which is immediately following the
header. (e.g. section 8.3.1)  
Yes.
However, this is in contradiction with section 8.8 which states, "When
present, the Session-Id SHOULD appear immediately following the Diameter
Header (see Section 3)."
No.
By using "SHOULD", the spec is stating that the session-ID AVP could be in
any position in the message.

No, it is stating that the AVP could be in any position in some message.
The syntax of the existing messages in RFC 3588 is defined by the associated
BNF and in those messages the Session-Id AVP must immediately follow the
Diameter header.

Hope this helps.

 ~gwz